import { select, range, scaleOrdinal } from 'd3';

const svg = select('svg');

let fruits; 

fruits = range(5).map(f => {
	return {type : 'apple'}
});

const colorOrdinal = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range(['red', 'yellow']); 

const sizeOrdinal = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range([50, 30]); 

const render = (el, {fruits}) => {
  
  let groups = el.selectAll('g')
  	.data(fruits);
  
  let gEnter = groups.enter().append('g');
  
  	gEnter.merge(groups).attr('transform', (d, i) =>  `translate(${i * 120 + 100}, 150)`)
  	
  	groups.exit().remove();
  
     gEnter
     .append('circle')
  	 .merge(groups.select('circle'))
  	  .transition().duration(1000)
    	.attr('r', (d) => sizeOrdinal(d.type))
      .attr('fill', (d, i) => colorOrdinal(d.type));

     gEnter
     .append('text')
  	 .merge(groups.select('text'))
  	  .transition().duration(1000)
    	.text( (d) => d.type)
      .attr('y', 120);
};


render(svg, {fruits});

setTimeout(() => {

	fruits.pop();
	render(svg, {fruits});
  
}, 1000)


setTimeout(() => {
	fruits[2].type = 'lemon';
	render(svg, {fruits});
  console.log(fruits)
  
}, 2000)

